﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace PaintApp
{
	public partial class InsertStringForm : Form
	{
		public string String = "";
		public Color Color = Color.Black;
		public Font StringFont = null;

		public InsertStringForm()
		{
			InitializeComponent();

			buttonOK.DialogResult = DialogResult.OK;
			buttonCancel.DialogResult = DialogResult.Cancel;

			textBox1.TextChanged += TextBox1_TextChanged;
			buttonFont.Click += ButtonFont_Click;
		}

		protected override void OnLoad(EventArgs e)
		{
			StringFont = Font;
		}

		private void ButtonFont_Click(object sender, EventArgs e)
		{
			FontDialog dlg = new FontDialog();
			dlg.ShowColor = true;
			if(dlg.ShowDialog() == DialogResult.OK)
			{
				Bitmap bitmap = new Bitmap(pictureBox1.Width, pictureBox1.Height);
				Graphics g = Graphics.FromImage(bitmap);

				String = textBox1.Text;
				Color = dlg.Color;
				StringFont = dlg.Font;
				g.DrawString(String, StringFont, new SolidBrush(Color), new Point(0, 0));
				g.Dispose();
				if(pictureBox1.Image != null)
					pictureBox1.Image.Dispose();
				pictureBox1.Image = bitmap;
			}
			dlg.Dispose();
		}

		private void TextBox1_TextChanged(object sender, EventArgs e)
		{
			Bitmap bitmap = new Bitmap(pictureBox1.Width, pictureBox1.Height);
			Graphics g = Graphics.FromImage(bitmap);

			String = textBox1.Text;
			g.DrawString(String, StringFont, new SolidBrush(Color), new Point(0, 0));
			g.Dispose();
			if(pictureBox1.Image != null)
				pictureBox1.Image.Dispose();
			pictureBox1.Image = bitmap;
		}
	}
}
