﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace PaintApp
{
	public partial class SizeChangeForm : Form
	{
		// 編集中のビットマップの幅と高さ
		public int bmpWidth = 0;
		public int bmpHeight = 0;

		public int newWidth = 0;
		public int newHeight = 0;

		public SizeChangeForm()
		{
			InitializeComponent();

			buttonOK.DialogResult = DialogResult.OK;
			buttonCancel.DialogResult = DialogResult.Cancel;

			buttonOK.Click += ButtonOK_Click;

			pixelRadioButton.CheckedChanged += PixelRadioButton_CheckedChanged;
			percentRadioButton.CheckedChanged += PercentRadioButton_CheckedChanged;

			pixelWidthUpDown.ValueChanged += PixelWidthUpDown_ValueChanged;
			pixelHeightUpDown.ValueChanged += PixelHeightUpDown_ValueChanged;

			//pixelWidthUpDown.textc

			percentWidthUpDown.ValueChanged += PercentWidthUpDown_ValueChanged;
			percentHeightUpDown.ValueChanged += PercentHeightUpDown_ValueChanged;

			checkBox1.CheckedChanged += CheckBox1_CheckedChanged;

			pixelRadioButton.Checked = true;
		}

		private void CheckBox1_CheckedChanged(object sender, EventArgs e)
		{
			if(checkBox1.Checked)
			{
				percentHeightUpDown.Enabled = false;
				pixelHeightUpDown.Enabled = false;

				decimal percent = percentWidthUpDown.Value;
				percentHeightUpDown.Value = percent;
				pixelHeightUpDown.Value = bmpHeight * percent / 100;
			}
			else
			{
				if(pixelRadioButton.Checked)
					pixelHeightUpDown.Enabled = true;
				else
					percentHeightUpDown.Enabled = true;
			}
		}

		private void PixelWidthUpDown_ValueChanged(object sender, EventArgs e)
		{
			if(pixelWidthUpDown.Enabled)
				percentWidthUpDown.Value = 100 * pixelWidthUpDown.Value / bmpWidth;
			if(checkBox1.Checked)
			{
				decimal percent = 100 * pixelWidthUpDown.Value / bmpWidth;
				percentHeightUpDown.Value = percent;
				pixelHeightUpDown.Value = bmpHeight * percent / 100;
			}
		}

		private void PixelHeightUpDown_ValueChanged(object sender, EventArgs e)
		{
			if(pixelHeightUpDown.Enabled)
				percentHeightUpDown.Value = 100 * pixelHeightUpDown.Value / bmpHeight;
		}

		private void PercentWidthUpDown_ValueChanged(object sender, EventArgs e)
		{
			if(percentWidthUpDown.Enabled)
				pixelWidthUpDown.Value = bmpWidth * percentWidthUpDown.Value / 100;
			if(checkBox1.Checked)
			{
				decimal percent = percentWidthUpDown.Value;
				percentHeightUpDown.Value = percent;
				pixelHeightUpDown.Value = bmpHeight * percent / 100;
			}
		}

		private void PercentHeightUpDown_ValueChanged(object sender, EventArgs e)
		{
			if(percentHeightUpDown.Enabled)
				pixelHeightUpDown.Value = bmpHeight * percentHeightUpDown.Value / 100;
		}


		private void PercentRadioButton_CheckedChanged(object sender, EventArgs e)
		{
		}

		private void PixelRadioButton_CheckedChanged(object sender, EventArgs e)
		{
			if(pixelRadioButton.Checked)
			{
				pixelWidthUpDown.Enabled = true;
				pixelHeightUpDown.Enabled = true;
				percentWidthUpDown.Enabled = false;
				percentHeightUpDown.Enabled = false;
			}
			else
			{
				pixelWidthUpDown.Enabled = false;
				pixelHeightUpDown.Enabled = false;
				percentWidthUpDown.Enabled = true;
				percentHeightUpDown.Enabled = true;
			}
		}

		private void ButtonOK_Click(object sender, EventArgs e)
		{
			newWidth = (int)pixelWidthUpDown.Value;
			newHeight = (int)pixelHeightUpDown.Value;
		}

		private void SizeChangeForm_Load(object sender, EventArgs e)
		{
			percentWidthUpDown.Value = 100;
			percentHeightUpDown.Value = 100;

			pixelWidthUpDown.Value = bmpWidth;
			pixelHeightUpDown.Value = bmpHeight;
		}

		
	}
}
