﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Drawing.Imaging;
using System.Reflection;

namespace PaintApp
{
    public partial class UserControlImage : UserControl
    {
		void OnMouseDownForMoveSelection(Point clickedBitmapPoint)
		{
			isMouseDownForMove = true;
			pictureBox1.Capture = true;

			rectangleMoveStartMousePosX = clickedBitmapPoint.X;
			rectangleMoveStartMousePosY = clickedBitmapPoint.Y;

			rectangleMoveStartLocationX = BitmapRectangle.X;
			rectangleMoveStartLocationY = BitmapRectangle.Y;
		}

		void OnMouseMoveForMoveSelection(Point bitmapPoint)
		{
			if(BitmapRectangle == null)
				return;

			int xMove = bitmapPoint.X - rectangleMoveStartMousePosX;
			int yMove = bitmapPoint.Y - rectangleMoveStartMousePosY;

			BitmapRectangle.X = rectangleMoveStartLocationX + xMove;
			BitmapRectangle.Y = rectangleMoveStartLocationY + yMove;

			InvalidatePictureBox();
		}

		void OptimizationScrloolBar(Bitmap bitmap)
		{
			// 横スクロールバーの初期位置、最小値、最大値を設定
			hScrollBar1.Minimum = 0;
			int pictureBoxWidth = (int)(pictureBox1.Width / DisplayMagnification);
			if(bitmap.Width - pictureBoxWidth >= 0)
			{
				int largeChange = pictureBox1.Width * pictureBoxWidth / bitmap.Width;
				hScrollBar1.LargeChange = largeChange;
				hScrollBar1.Maximum = bitmap.Width - pictureBoxWidth + largeChange;
			}
			else
				hScrollBar1.Maximum = 0;

			// 縦スクロールバーと横スクロールバーの初期位置、最小値、最大値を設定する
			vScrollBar1.Minimum = 0;
			int pictureBoxHeight = (int)(pictureBox1.Height / DisplayMagnification);
			if(bitmap.Height - pictureBoxHeight >= 0)
			{
				int largeChange = pictureBox1.Height * pictureBoxHeight / bitmap.Height;
				vScrollBar1.LargeChange = largeChange;
				vScrollBar1.Maximum = bitmap.Height - pictureBoxHeight + largeChange;
			}
			else
				vScrollBar1.Maximum = 0;
		}

		void DrawFieldGrip(Bitmap bitmap, Graphics g)
		{
			if(pictureBox1.Image != null)
				pictureBox1.Image = null;

			int width = (int)(bitmap.Width * DisplayMagnification);
			int height = (int)(bitmap.Height * DisplayMagnification);

			int scrollBarPosX = (int)(ScrollBarPosX * DisplayMagnification);
			int scrollBarPosY = (int)(ScrollBarPosY * DisplayMagnification);

			int x = width - scrollBarPosX - GriperSize;
			int y = height - scrollBarPosY - GriperSize;

			g.DrawRectangle(new Pen(Color.LightGray), new Rectangle(x, y, GriperSize, GriperSize));

			x = width / 2 - scrollBarPosX - GriperSize / 2;
			y = height - scrollBarPosY - GriperSize;
			g.DrawRectangle(new Pen(Color.LightGray), new Rectangle(x, y, GriperSize, GriperSize));

			x = width - scrollBarPosX - GriperSize;
			y = height / 2 - scrollBarPosY - GriperSize / 2;
			g.DrawRectangle(new Pen(Color.LightGray), new Rectangle(x, y, GriperSize, GriperSize));

			g.DrawRectangle(new Pen(Color.LightGray), new Rectangle(-1, -1, width - scrollBarPosX + 1, height - scrollBarPosY + 1));
		}
	}
}

